;pano_ubz.asm : programme associ au montage adaptateur "analyseur panoramique pour TV"
;par F1UBZ loic MARTY loicmarty@wanadoo.Fr
;a utitiser et a copier pour toute application NON commerciale
;ralis le 01 mai 2001
;a0= NC
;a1= synchro ccir
;a2= acquisition / lecture
;a3= ligne visible dans l'ecran
;a4 = NC
		include "p16f84.inc"  
compteur1       equ 0c    
compteur2       equ 0d
compteur3       equ 0e
nb              equ 0f
flag_ligne	equ 10
data_tx         equ 11
tempo           equ 12
                org 0
		goto debut               
		ORG 5
debut		clrf PORTB
		bsf STATUS,RP0      ;on passe en bank 1 
	        clrf TRISA
		clrf TRISB	    ;portb en sortie
	       	bcf STATUS,RP0      ;on repasse en bank 0
		clrf PORTA
		clrf PORTB
		clrf compteur1
		clrf compteur2       
		movlw d'38'
		movwf compteur3     ;preset a 38 du compteur 3
boucle_64us     clrf flag_ligne
		bcf PORTA,3         ;fin de ligne precedante valide 
                bcf PORTA,1         ;synchro ligne a 0
		nop
		incfsz compteur1,1  ;compteur1=compteur1+1 et deborde t'il??
	        decf compteur2,1    ;[non]compteur2=compteur2-1 [oui=nop]
                incf compteur2,1    ;[oui/non] compteur2= compteur2+1 
 		bsf PORTA,1         ;synchro ligne a 1 [duree=5us]
	        decfsz compteur3,1   ;tant que l'on a pas atteint 38 lignes
		goto saut1	    ;apres l'egalisation on saute l'operation
		movlw 1             ;sur le portB
		movwf compteur3     ;compteur 3 a 1 pour repasser ici la 
		bsf PORTA,3         ;ligne suivante : ici ligne visible
		decfsz PORTB,1	    ;	
		goto saut2
		clrf compteur3      ;c3 a 0 => fin de ligne ok =>portb=0
		goto saut3
saut1           nop
		nop
		nop
		nop
		nop
saut2           nop
		nop
saut3          	movlw d'1'    	     	
		xorwf compteur2,0	     
		btfsc STATUS,Z       ;compteur2=1??
		bsf flag_ligne,0     ;oui flag0=1 sinon flag0=0
		movlw d'2'    	     
		xorwf compteur2,0	    
		btfsc STATUS,Z       ;compteur2=2??
		bsf flag_ligne,1     ;oui flag1=1 sinon flag1=0
		movlw d'53'    	     
		xorwf compteur1,0	    
		btfsc STATUS,Z       ;compteur1=53??
		bsf flag_ligne,2     ;oui flag2=1 sinon flag2=0
		movlw d'110'    	     
		xorwf compteur1,0	    
		btfsc STATUS,Z       ;compteur1=110??
		bsf flag_ligne,3     ;oui flag3=1 sinon flag3=0
		movlw b'00001010'    ;ligne 622 <=> flag1=1 et flag3=1
		xorwf flag_ligne,0   
		btfsc STATUS,Z	     ;ligne = 622 ?
		goto l_622	     ;oui 		
		movlw b'00000101'    ;ligne 309 <=> flag0=1 et flag2=1
		xorwf flag_ligne,0   
		btfsc STATUS,Z	     ;ligne = 309 ?
		goto l_309	     ;oui 
		movlw d'2'    	     	
		xorwf compteur3,0	     
		btfsc STATUS,Z       ;compteur3=2 => creneau de fin d'enregistrement
		bcf PORTA,2
		movlw d'253'         ;quelques lignes avant la visibilt	     	
		xorwf compteur3,0	     
		btfsc STATUS,Z       ;compteur 255 => creneau de debut d'enregistrement
		bsf PORTA,2
		call attente_4us
		call attente_4us
		call attente_4us
		goto boucle_64us     ;ligne restante...
;
l_309           call attente_4us
		call attente_4us
		call attente_4us
		call attente_4us
		call attente_4us         		
                nop
		nop
		nop
		bcf PORTA,1          ;fin de ligne 309... puis ligne 309
		call attente_4us
	        bsf PORTA,1          ;synchro de la ligne 310
		call attente_24us    ;attente 54us
		call attente_24us
		call attente_4us
		nop
		nop
                call egalisation
		movlw d'62'	     ;a la fin de la routine d'egalisation	
		movwf compteur1      ;le compteur de ligne doit etre a 318
		call attente_24us    ;attente 50us  		    
		call attente_24us
		nop
		nop
		goto boucle_64us
;		
l_622           call attente_24us    ;fin de ligne 622... 
		nop
		nop
		nop
               	bcf PORTA,1         
		call attente_4us
	        bsf PORTA,1          ;synchro de la ligne 623
                call attente_4us     ;attente 22us
		call attente_4us
		call attente_4us
		call attente_4us
		call attente_4us
		nop
		nop
		call egalisation     
		clrf compteur2	     ;a la fin de la routine d'egalisation 	
 		movlw 5              ;le compteur de ligne doit etre a 5        
		movwf compteur1
	        call attente_4us     ;attente 17us	
		call attente_4us
		call attente_4us
		call attente_4us
		nop
		goto  boucle_64us
;
egalisation     call impul_courte    ;1ere impulsion courte
		call attente_24us    
                call impul_courte    ;2eme impulsion courte
                call attente_24us			
		call impul_courte    ;3eme impulsion courte
                call attente_24us			
		call impul_courte    ;4eme impulsion courte
		call attente_24us	
                call impul_courte    ;5eme impulsion courte
                call attente_24us
		bcf STATUS,C		
		nop
		bcf PORTA,1           
	        nop
		clrf PORTB
		call attente_4us
         	call attente_4us
		call attente_4us
		call attente_4us
		call attente_4us
		nop
		nop
		movlw d'38'
		movwf compteur3
		bsf PORTA,1
		call attente_4us      ;1ere impulsion large	
		bcf PORTA,1
		nop
		nop
		call attente_24us     ;voir le debut des lignes actives	
		bsf PORTA,1
		call attente_4us      ;2eme impulsion large	
		bcf PORTA,1
		nop
		nop
		call attente_24us
		bsf PORTA,1
		call attente_4us      ;3eme impulsion large	
		bcf PORTA,1
		nop
		nop
		call attente_24us
		bsf PORTA,1
		call attente_4us      ;4eme impulsion large
                bcf PORTA,1
		nop
		nop
		call attente_24us
		bsf PORTA,1
		call attente_4us      ;5eme impulsion large	
		bcf PORTA,1
                bsf PORTA,1           ;6eme impulsion courte
		call attente_4us
		call attente_24us
		call impul_courte     ;7eme impulsion courte 
		call attente_24us
		call impul_courte     ;8eme impulsion courte
		call attente_24us
		call impul_courte     ;9eme impulsion courte		
		call attente_24us
		call impul_courte     ;10eme impulsion courte
		return 
;		
impul_courte    bcf PORTA,1        ;routine d'impulsion courte de la synchro
		nop		   ;l'impulsion dure 2us et a lieu 3 us apres	
                bsf PORTA,1	   ;l'appel de la routine:la routine dure 8us
		nop                ;incluant l'appel et le retour
                return		      
;
attente_4us     return    	   ;sans commentaire...
; 
attente_24us    nop
                movlw 6	     ;routine d'attente 24 us incluant l'appel
	        movwf nb           ;et le retour
suivant		decfsz nb,1
		goto suivant       
		return
;
		end

        
